#!/bin/csh -f

if ($#argv == 0) then
	echo Usage: $0 phpl ...
	echo outputs phpl.cnf in dimacs format, input is prolog format.
	exit 0
	endif

foreach f ($*)
	tr -d '(),.' < $f | sed 's/$/ 0/' > $f.tmp
	set nlines = `wc -l $f.tmp | awk '{print $1;}' `
	# nclauses = n*(n-1)*(n-1)/2 + n
	# nvars = n*(n-1)
	@ n = 0
	@ nclauses = 0

	while ($nclauses < $nlines)
		@ n = $n + 1
		@ h = $n - 1
		if ($n == 10 || $n == 100 || $n == 1000 || $n == 10000) then
			set h = 0$h
			endif
		@ nvars = $n * $h
		@ nclauses= ( ( $nvars * $h ) / 2 ) + $n
		end
	echo c $n pigeons and $h holes > $f.cnf
	echo p cnf $n$h $nclauses >> $f.cnf
	cat $f.tmp >> $f.cnf
	if ($nclauses != $nlines) then
		echo BAD FMLA $f.cnf clauses should be $nclauses found $nlines
		endif
	/bin/rm $f.tmp
	end
